author:  Jason/Andy


> meaning of label, assignees, etc.
> triage process
> requirements for resolving (timing), closing... 

## Long-living issue labels

### Feature areas

These labels describe what feature area of PowerShell that an issue addresses.

* `Area-Build`: build issues
* `Area-Cmdlets`: cmdlets in any module
* `Area-Console`: the console experience
* `Area-Debugging`: debugging PowerShell script
* `Area-Documentation`: PowerShell *repo* documentation issues, general PowerShell doc issues go [here](https://github.com/PowerShell/PowerShell-Docs/issues)
* `Area-Engine`: core PowerShell engine, interpreter, runtime
* `Area-Intellisense`: tab completion
* `Area-Language`: parser, language semantics
* `Area-OMI`: omi
* `Area-PackageManagement`: PackageManagement related issues
* `Area-Performance`: a performance issue 
* `Area-Portability`: anything affecting script portability
* `Area-PSReadline`: PSReadLine
* `Area-SideBySide`: Side by side support
* `Area-Test`: tests or test infrastructure

### Operating systems

These are for issues that are specific to certain operating systems:
* `OS-Linux`
* `OS-OS X`
* `OS-Windows`

### Process Tags

Issues can be in one of the following states:
* `0 - Backlog` : We've acknowledged the issue but have no immediate plans to address it.
* `1 - Planning` : The issue requires some design or discussion before coding can begin.
* `2 - Ready` : Any design or discussion is essentially done, coding has not yet begun though.
* `3 - Working` : The assignee(s) are actively working on the issue.
* `4 - In Review` : The issue is being reviewed.
The assignee(s) are responsible for signing off before the PR will be merged.

* `help wanted` : We are looking for someone to work on this issue.
* `need review` : This Pull Request is being reviewed.  Please see [Pull Request - Code Review](../../.github/CONTRIBUTING.md#pull-request-code-review)
